﻿Imports System.IO

'***************************************
'*                                     *
'*  ANAGRAMMI BY CARLO BARABUCCI 2020  *
'*                                     *
'***************************************

Public Class Form1

    Dim Vocabolario As List(Of String)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' caricamento del vocabolario completo in una lista di stringhe
        Vocabolario = File.ReadAllLines(Application.StartupPath & "\VocabolarioItaliano.txt").ToList
        Me.Text = "Anagrammi  ©CB2020    [" & Vocabolario.Count & " parole in linea]"
    End Sub

    Private Sub TextParola_KeyDown(sender As Object, e As KeyEventArgs) Handles TextParola.KeyDown
        If e.KeyValue = Keys.Return Then
            TextParola.Text = Trim(TextParola.Text.ToLower)
            RiempiCombo(TextParola.Text.Length)
            If TextParola.Text.Contains("?") Then
                SostituisciInterrogativi(TextParola.Text)
            Else
                Ricerca(TextParola.Text)
            End If
        End If
    End Sub

    Private Sub ListBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox2.SelectedIndexChanged
        TextParola.Text = ListBox2.SelectedItem.ToLower
        RiempiCombo(TextParola.Text.Length)
        Ricerca(TextParola.Text)
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        TextParola.Text = ListBox1.SelectedItem.ToLower
        RiempiCombo(TextParola.Text.Length)
        Ricerca(TextParola.Text)
    End Sub

    Private Sub ButAggiungi_Click(sender As Object, e As EventArgs) Handles ButAggiungi.Click
        ButAggiungi.Enabled = False
        If TextParola.Text.Length > 0 Then
            Me.Enabled = False
            ListBox1.Items.Clear()
            ListBox1.Items.Add(TextParola.Text.ToLower)
            ListBox1.Items.Add("aggiungo al vocabolario")
            ListBox1.Refresh()
            Vocabolario.Add(TextParola.Text.ToLower)
            ListBox1.Items.Add("riordino vocabolario")
            ListBox1.Refresh()
            Vocabolario.Sort()
            ListBox1.Items.Add("salvo vocabolario")
            ListBox1.Refresh()
            File.WriteAllLines(Application.StartupPath & "\VocabolarioItaliano.txt", Vocabolario)
            Me.Enabled = True
        End If
    End Sub

    Private Sub ButElimina_Click(sender As Object, e As EventArgs) Handles ButElimina.Click
        ButElimina.Enabled = False
        If TextParola.Text.Length > 0 Then
            Vocabolario.Remove(TextParola.Text.ToLower)
            ListBox1.Items.Clear()
            ListBox1.Items.Add(TextParola.Text.ToLower)
            ListBox1.Items.Add("rimosso/a dal vocabolario")
            ListBox1.Refresh()
            File.WriteAllLines(Application.StartupPath & "\VocabolarioItaliano.txt", Vocabolario)
            ListBox1.Items.Add("vocabolario salvato")
            ListBox1.Refresh()
        End If
    End Sub

    Private Sub TextParola_TextChanged(sender As Object, e As EventArgs) Handles TextParola.TextChanged
        ButElimina.Enabled = False
        ButAggiungi.Enabled = False
        If TextParola.Text.Contains("?") Then
            LabInfo.Text = "i ""?"" verranno sostituiti con le lettere mancanti"
        Else
            LabInfo.Text = "Parola senza accenti, poi invio, usa anche ""?"""
        End If
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        Ricerca(TextParola.Text)
    End Sub

    Private Sub Ricerca(ParolaCercata As String)
        ListBox1.Items.Clear()
        Dim parole As UInt32 = 0 ' indice del vocabolario
        Dim NumCaratteriOr As Byte = Convert.ToByte(ParolaCercata.Length)
        Dim NumCaratteriCerca As Byte = Convert.ToByte(ComboBox1.Text)
        ListBox1.BeginUpdate()
        For parole = 0 To Vocabolario.Count - 1
            ' controllo solo le parole che hanno la stessa lunghezza della parola digitata, o dei caratteri scelti
            If Vocabolario(parole).Length = NumCaratteriCerca Then
                Dim ParolaInAnalisi As String = Vocabolario(parole) ' duplico la parola del vocabolario in una variabile temporanea, perché la modificherò
                For PT = 0 To NumCaratteriOr - 1 ' ciclo lettera per lettera
                    Dim pos As Int16 = ParolaInAnalisi.IndexOf(ParolaCercata(PT), 0, ParolaInAnalisi.Length) ' posizione della lettera attuale (ParolaCercata(PT)), nella parola in analisi (ParolaInAnalisi)
                    If pos > -1 Then
                        ParolaInAnalisi = ParolaInAnalisi.Remove(pos, 1) ' la lettera in analisi è contenuta nella parola del vocabolario (ParolaInAnalisi), la elimino
                    End If
                Next
                If ParolaInAnalisi = "" Then ' se non resta nessuna lettera, significa che la parala del vocabolario è un anagramma della parola digitata
                    If NumCaratteriCerca < NumCaratteriOr Then ' se i caratteri cercati sono meno della lunghezza della parola digitata ci sarà una rimanenza
                        ParolaInAnalisi = ParolaCercata ' duplico la parola cercata in una variabile temporanea, perché la modificherò
                        For PT = 0 To NumCaratteriCerca - 1 ' ciclo lettera per lettera
                            Dim pos As Int16 = ParolaInAnalisi.IndexOf(Vocabolario(parole)(PT), 0, ParolaInAnalisi.Length) ' posizione della lettera attuale (ParolaCercata(PT)), nella parola in analisi (ParolaInAnalisi)
                            If pos > -1 Then
                                ParolaInAnalisi = ParolaInAnalisi.Remove(pos, 1) ' la lettera in analisi è contenuta nella parola del vocabolario (ParolaInAnalisi), la elimino
                            End If
                        Next
                        ' in ParolaInAnalisi restano le lettere in avanzo
                        ListBox1.Items.Add(Vocabolario(parole) & "   [-" & ParolaInAnalisi & "]") ' mostro la parola del vocabolario che risponde al requisito di anagramma, con le lettere in eccesso
                    Else
                        ListBox1.Items.Add(Vocabolario(parole)) ' mostro la parola del vocabolario che risponde al requisito di anagramma
                    End If
                End If
            End If
        Next
        ListBox1.Items.Add("- " & ListBox1.Items.Count & " corrispondenze -")
        ListBox1.EndUpdate()
        If NumCaratteriCerca = NumCaratteriOr Then ' solo se gli anagrammi sono della stessa lunghezza della parola digitata
            ' se la parola digitata (ParolaCercata) compare anche in ListBox1, significa che è contenuta nel vocabolario
            If ListBox1.Items.Contains(ParolaCercata) Then
                ' è contenuta la posso eliminare
                ButAggiungi.Enabled = False
                ButElimina.Enabled = True
            Else
                ' non è contenuta la posso aggiungere
                ButAggiungi.Enabled = True
                ButElimina.Enabled = False
            End If
        End If
        TextParola.Focus()
        TextParola.DeselectAll()
    End Sub

    Private Sub RiempiCombo(NumCaratteri As Byte)
        ComboBox1.Items.Clear()
        ComboBox1.Text = NumCaratteri
        For Quante = NumCaratteri To 2 Step -1
            ComboBox1.Items.Add(Quante)
        Next
    End Sub

    Private Sub SostituisciInterrogativi(ParolaCercata As String)
        ListBox1.Items.Clear()
        Dim parole As UInt32 = 0 ' indice del vocabolario
        Dim NumCaratteriOr As Byte = Convert.ToByte(ParolaCercata.Length)

        ListBox1.BeginUpdate()
        For parole = 0 To Vocabolario.Count - 1
            ' controllo solo le parole che hanno la stessa lunghezza della parola digitata, compresi i ?
            If Vocabolario(parole).Length = NumCaratteriOr Then
                Dim Parola As Boolean = True
                Dim PrimoInterrogativo As Boolean = True
                Dim divisa(NumCaratteriOr, 1) As String
                Dim pos As Byte = 0
                Dim LettereNote As Byte
                divisa(0, 0) = "" ' inizializzo la posizione che serve se viene digitato un ? in prima posizione
                For LettereNote = 0 To NumCaratteriOr - 1 ' ciclo delle lettere
                    ' in divisa(x,0) ci saranno le stringhe note, detratti i ?
                    ' in divisa(x,1) ci saranno le posizioni di partenza delle stringhe (pos)
                    If ParolaCercata(LettereNote) = "?" Then
                        If PrimoInterrogativo Then divisa(pos, 1) = LettereNote - divisa(pos, 0).Length : pos += 1
                        PrimoInterrogativo = False
                    Else
                        divisa(pos, 0) += ParolaCercata(LettereNote)
                        PrimoInterrogativo = True
                    End If
                Next
                ' se è stato digitato un ? alla fine della parola digitata, aggiusto pos per considerarlo nella ricerca
                If ParolaCercata.Substring(ParolaCercata.Length - 1, 1) = "?" Then
                    pos -= 1
                Else
                    divisa(pos, 1) = LettereNote - divisa(pos, 0).Length
                End If
                ' quando la matrice divisa è stata riempita con le stringhe note e relative posizioni
                ' posso verificare che la parola in esame presa dal vocabolario le contenga tutte e nella giusta posizione.
                For test = 0 To pos
                    If Vocabolario(parole).Substring(divisa(test, 1), divisa(test, 0).Length) <> divisa(test, 0) Then Parola = False : Exit For
                Next
                If Parola Then ListBox1.Items.Add(Vocabolario(parole)) ' tutte le stringe sono presenti
            End If
        Next
        ListBox1.Items.Add("- " & ListBox1.Items.Count & " corrispondenze -")
        ListBox1.EndUpdate()
    End Sub

 
End Class
